<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: ButtonsCommanderAnalogPushes Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classButtonsCommanderAnalogPushes.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classButtonsCommanderAnalogPushes-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">ButtonsCommanderAnalogPushes Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="ButtonsCommanderAnalogPushes_8hpp_source.html">ButtonsCommanderAnalogPushes.hpp</a>&quot;</code></p>
<div class="dynheader">
Inheritance diagram for ButtonsCommanderAnalogPushes:</div>
<div class="dyncontent">
 <div class="center">
  <img src="classButtonsCommanderAnalogPushes.png" usemap="#ButtonsCommanderAnalogPushes_map" alt=""/>
  <map id="ButtonsCommanderAnalogPushes_map" name="ButtonsCommanderAnalogPushes_map">
<area href="classButtonsCommanderButton.html" alt="ButtonsCommanderButton" shape="rect" coords="0,0,201,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a838603d13e894d923700ec9ad9958cd7"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderAnalogPushes.html#a838603d13e894d923700ec9ad9958cd7">ButtonsCommanderAnalogPushes</a> ()</td></tr>
<tr class="separator:a838603d13e894d923700ec9ad9958cd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afdee2008ec1f6f3f276bfa6193bfa60c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderAnalogPushes.html#afdee2008ec1f6f3f276bfa6193bfa60c">begin</a> (int inButtonPin, uint8_t inNumber, unsigned long *inpIds, int *inpButtonValues, int inTolerancy = 20)</td></tr>
<tr class="separator:afdee2008ec1f6f3f276bfa6193bfa60c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab72557e2f070f17498f5e43f82ec52f3"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderAnalogPushes.html#ab72557e2f070f17498f5e43f82ec52f3">loop</a> ()</td></tr>
<tr class="separator:ab72557e2f070f17498f5e43f82ec52f3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed6eacfc1656e7aacd24cf3ab6565ea1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderAnalogPushes.html#aed6eacfc1656e7aacd24cf3ab6565ea1">EndLoop</a> ()</td></tr>
<tr class="separator:aed6eacfc1656e7aacd24cf3ab6565ea1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6f796b9880e1d9b7a41a26fdf972a3c0"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classButtonsCommanderAnalogPushesItem.html">ButtonsCommanderAnalogPushesItem</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderAnalogPushes.html#a6f796b9880e1d9b7a41a26fdf972a3c0">GetItem</a> (uint8_t inNumber)</td></tr>
<tr class="separator:a6f796b9880e1d9b7a41a26fdf972a3c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae976e740dfe282cf22e107cfa6b13dc3"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderAnalogPushes.html#ae976e740dfe282cf22e107cfa6b13dc3">GetFromId</a> (unsigned long inId)</td></tr>
<tr class="separator:ae976e740dfe282cf22e107cfa6b13dc3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af42beb367b2a6278527ef79a30cd892d"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderAnalogPushes.html#af42beb367b2a6278527ef79a30cd892d">GetLastButtonPressed</a> () const </td></tr>
<tr class="separator:af42beb367b2a6278527ef79a30cd892d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classButtonsCommanderButton"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classButtonsCommanderButton')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></td></tr>
<tr class="memitem:afd8cb1a2b76510830062c5656bda0728 inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#afd8cb1a2b76510830062c5656bda0728">ButtonsCommanderButton</a> (unsigned long inId)</td></tr>
<tr class="separator:afd8cb1a2b76510830062c5656bda0728 inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbdd1d63fed7736c7358105428fbfd9c inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#acbdd1d63fed7736c7358105428fbfd9c">GetId</a> () const </td></tr>
<tr class="separator:acbdd1d63fed7736c7358105428fbfd9c inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a823f11a7de3a5a01d0c076f7d5b4fae0 inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">virtual int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a823f11a7de3a5a01d0c076f7d5b4fae0">GetPosition</a> () const </td></tr>
<tr class="separator:a823f11a7de3a5a01d0c076f7d5b4fae0 inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae1f260c75fbe475f674107bdc96f26cd inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#ae1f260c75fbe475f674107bdc96f26cd">beforeFirstLoop</a> ()</td></tr>
<tr class="separator:ae1f260c75fbe475f674107bdc96f26cd inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7fa0ef8aede172936672b384f81b03bb inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a7fa0ef8aede172936672b384f81b03bb">SetNextButton</a> (ButtonsCommanderButton *inpButton)</td></tr>
<tr class="separator:a7fa0ef8aede172936672b384f81b03bb inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dac1c9fcdc5bbe1d2b00a38192f555c inherit pub_methods_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">ButtonsCommanderButton *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a0dac1c9fcdc5bbe1d2b00a38192f555c">GetNextButton</a> () const </td></tr>
<tr class="separator:a0dac1c9fcdc5bbe1d2b00a38192f555c inherit pub_methods_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pro_attribs_classButtonsCommanderButton"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classButtonsCommanderButton')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a></td></tr>
<tr class="memitem:a3b40667770ab04694a2ea85f11aebfe0 inherit pro_attribs_classButtonsCommanderButton"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classButtonsCommanderButton.html#a3b40667770ab04694a2ea85f11aebfe0">Id</a></td></tr>
<tr class="separator:a3b40667770ab04694a2ea85f11aebfe0 inherit pro_attribs_classButtonsCommanderButton"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>A push button is a hardware device giving a time limited impulsion. It will return one Dccid at a time, passing through the whole list of DccIds. The analog pushes variant use one analog pin with some pushes connected through resistors.</p>
<pre class="fragment">Sample for five pushes.
+        +         +         +         + GND
|        |         |         |         |
/        /         /         /         / Pushes
|        |         |         |         |
| 3kOhms | 1kOhms  | 620 Ohms| 330 Ohms|
|        |         |         |         |
+--***---+---***---+---***---+---***---+------&gt; Analog pin
                                       |
                                       *
                                       * 10kOhms
                                       *
                                       |
                                       + 5v
</pre><p>When one push button is pressed, the value read on the analog pin depends of the resistor addition from the button to the pin. It is important that only one button was pushed at a time. It is possible to use more or less buttons, but resistor values have to be computed to avoid confusing analog values between near pushes...</p>
<p>This class is a list of <a class="el" href="classButtonsCommanderAnalogPushesItem.html">ButtonsCommanderAnalogPushesItem</a>, basicaly a push button. Each item has its own id, analog value and tolerancy interval.</p>
<p>Events thrown:</p>
<table class="doxtable">
<tr>
<th>reason </th><th>id </th><th>type </th><th>data  </th></tr>
<tr>
<td>pin state to LOW </td><td>push id </td><td><a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490ca4c6e59b277bf1f4430a136faab150a61">COMMANDERS_EVENT_MOVEPOSITIONID</a> </td><td>0 </td></tr>
</table>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderAnalogPushes_8hpp_source.html#l00049">49</a> of file <a class="el" href="ButtonsCommanderAnalogPushes_8hpp_source.html">ButtonsCommanderAnalogPushes.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a838603d13e894d923700ec9ad9958cd7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">ButtonsCommanderAnalogPushes::ButtonsCommanderAnalogPushes </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Default constructor. </p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00011">11</a> of file <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html">ButtonsCommanderAnalogPushes.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="afdee2008ec1f6f3f276bfa6193bfa60c"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void ButtonsCommanderAnalogPushes::begin </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inButtonPin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>inNumber</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long *&#160;</td>
          <td class="paramname"><em>inpIds</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>inpButtonValues</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inTolerancy</em> = <code>20</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Initialize the instance. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inButtonPin</td><td>Analog Arduino pin connected to this group of pushes. </td></tr>
    <tr><td class="paramname">inNumber</td><td>number of push buttons. </td></tr>
    <tr><td class="paramname">inpIds</td><td>Array of ids of each button. </td></tr>
    <tr><td class="paramname">inpButtonValues</td><td>array of analog values, one for each button. </td></tr>
    <tr><td class="paramname">inTolerancy</td><td>tolerancy of the read analog value to identify the correct push button. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00022">22</a> of file <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html">ButtonsCommanderAnalogPushes.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="aed6eacfc1656e7aacd24cf3ab6565ea1"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ButtonsCommanderAnalogPushes::EndLoop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Reinitialize the list for future use. Called at the end of the loop, if an event has been raised. </p>

<p>Reimplemented from <a class="el" href="classButtonsCommanderButton.html#a270eade0db966b7e72b6dc5462377593">ButtonsCommanderButton</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00109">109</a> of file <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html">ButtonsCommanderAnalogPushes.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae976e740dfe282cf22e107cfa6b13dc3"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classButtonsCommanderButton.html">ButtonsCommanderButton</a> * ButtonsCommanderAnalogPushes::GetFromId </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets one push item through its id. </p>

<p>Reimplemented from <a class="el" href="classButtonsCommanderButton.html#a1ab1295abfbfafef48d38a8795fb0be7">ButtonsCommanderButton</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00048">48</a> of file <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html">ButtonsCommanderAnalogPushes.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="a6f796b9880e1d9b7a41a26fdf972a3c0"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classButtonsCommanderAnalogPushesItem.html">ButtonsCommanderAnalogPushesItem</a>* ButtonsCommanderAnalogPushes::GetItem </td>
          <td>(</td>
          <td class="paramtype">uint8_t&#160;</td>
          <td class="paramname"><em>inNumber</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets one push item. </p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderAnalogPushes_8hpp_source.html#l00082">82</a> of file <a class="el" href="ButtonsCommanderAnalogPushes_8hpp_source.html">ButtonsCommanderAnalogPushes.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="af42beb367b2a6278527ef79a30cd892d"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t ButtonsCommanderAnalogPushes::GetLastButtonPressed </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Gets the last push button pressed. </p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderAnalogPushes_8hpp_source.html#l00087">87</a> of file <a class="el" href="ButtonsCommanderAnalogPushes_8hpp_source.html">ButtonsCommanderAnalogPushes.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ab72557e2f070f17498f5e43f82ec52f3"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long ButtonsCommanderAnalogPushes::loop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Main loop function. </p>

<p>Reimplemented from <a class="el" href="classButtonsCommanderButton.html#a44bbb289ce1f64b42a88126e8dd42f7e">ButtonsCommanderButton</a>.</p>

<p class="definition">Definition at line <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html#l00057">57</a> of file <a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html">ButtonsCommanderAnalogPushes.cpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="ButtonsCommanderAnalogPushes_8hpp_source.html">ButtonsCommanderAnalogPushes.hpp</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="ButtonsCommanderAnalogPushes_8cpp_source.html">ButtonsCommanderAnalogPushes.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classButtonsCommanderAnalogPushes.html">ButtonsCommanderAnalogPushes</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
